﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Battleship
{
    /// <summary>
    /// Класс-сущность "Военный корабль с оружием"
    /// </summary>
    internal class EntityGunBattleship : EntityBattleship
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; private set; }
        /// <summary>
        /// Признак наличия отсека для ракет
        /// </summary>
        public bool CompartmentRocket { get; private set; }
        /// <summary>
        /// Признак наличия орудийной башни
        /// </summary>
        public bool GunTower { get; private set; }
        /// <summary>
        /// Признак наличия забора на корме
        /// </summary>
        public bool SternFence { get; private set; }
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес военного корабля</param>
        /// <param name="bodyColor">Цвет корпуса корабля</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="compartmentRocket">Признак наличия отсека для ракет</param>
        /// <param name="gunTower">Признак наличия орудийной башни</param>
        /// <param name="sternFence">Признак наличия забора на корме</param>
        public EntityGunBattleship(int speed, float weight, Color bodyColor, Color dopColor, bool compartmentRocket, bool gunTower, bool sternFence) :
            base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            CompartmentRocket = compartmentRocket;
            GunTower = gunTower;
            SternFence = sternFence;
        }

        public void ChangeDopColor(Color color)
        {
            DopColor = color;
        }
    }
}
