namespace Battleship
{
    public partial class FormBattleship : Form
    {
        private DrawningBattleship _battleship;
        /// <summary>
        ///  
        /// </summary>
        public DrawningBattleship SelectedBattleship { get; private set; }

        public FormBattleship()
        {
            InitializeComponent();
        }

        /// <summary>
		///    
		/// </summary>
		private void Draw()
        {
            Bitmap bmp = new(pictureBoxBattleship.Width, pictureBoxBattleship.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _battleship?.DrawTransport(gr);
            pictureBoxBattleship.Image = bmp;
        }
        /// <summary>
		///   
		/// </summary>
		private void SetData()
        {
            Random rnd = new();
            _battleship.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxBattleship.Width, pictureBoxBattleship.Height);
            toolStripStatusLabelSpeed.Text = $": {_battleship.Battleship.Speed}";
            toolStripStatusLabelWeight.Text = $": {_battleship.Battleship.Weight}";
            toolStripStatusLabeBodylColor.Text = $": {_battleship.Battleship.BodyColor.Name}";
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _battleship = new DrawningBattleship(rnd.Next(100, 300), rnd.Next(1000, 2000), color);
            SetData();
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _battleship?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _battleship?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _battleship?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _battleship?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PictureBoxBattleship_Resize(object sender, EventArgs e)
        {
            _battleship?.ChangeBorders(pictureBoxBattleship.Width, pictureBoxBattleship.Height);
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialogDop = new();
            if (dialogDop.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialogDop.Color;
            }
            _battleship = new DrawningGunBattleship(rnd.Next(100, 300), rnd.Next(1000, 2000), color, dopColor,
                Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }

        private void ButtonSelectBatlleship_Click(object sender, EventArgs e)
        {
            SelectedBattleship = _battleship;
            DialogResult = DialogResult.OK;

        }
    }
}